package com.offcn.api.xyzb;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.XYZB;

import net.sf.json.JSONObject;



/**
 * 根据room_num获取教师相关信息
 * 
 * @author puhui
 *
 */
public class get_teacher_info extends XYZB implements API {
	public String parameter;//参数集合
	public String Description;
	public String teacher_uuid;
	
	
	public String uuid;
	public String nickname;
	public String desc;
	public String pic;
	
	@Override
	public void initialize(HashMap<String, Object> data) {
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		parameter = MapUtil.getValue("parameter", data);
		teacher_uuid = MapUtil.getParameter(parameter, "teacher_uuid").trim();
		teacher_uuid = MapUtil.killQuotes(teacher_uuid, "\"");//去掉双引号的education
		
		
//		if ((!room_name.equals("")) && room_name.equals("code")) {
//			parameter = parameter.replace("\"room_name\":code", "\"room_name\":\""+ room_names.get("Not_edited") + "\"");
//		}
		
		if ((!teacher_uuid.equals("")) && teacher_uuid.equals("code")) {
			
			parameter =  "teacher_uuid="+Current_uuid;
			parameter = MapUtil.killQuotes(parameter, "\"");//去掉双引号的parameter
			data.put("parameter", parameter);
			return data;
		}
		
		// 替换原来的parameter
		data.put("parameter", teacher_uuid);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		// 获取parameter对应的内容
		Description = MapUtil.getValue("Description", data);
		
		if(Description.contains("错误token")){
			Response re = RequestDataUtils.Get_Errtoken(data, "/api/v1/users", Client_token);
			return re;
		}else if(Description.contains("超长token")){
			Response re = RequestDataUtils.Get_Longtoken(data, "/api/v1/users", Client_token);
			return re;
		}else if(Description.contains("无token")){
			Response re = RequestDataUtils.Get_Notoken(data, "/api/v1/users");
			return re;
		}
		Response re = RequestDataUtils.Get_token(data, Url,Client_token);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=StringUtils.decodeUnicode(jp.getString("msg"));
			
			if ((data.get("code") != null )
					&& ((jp.getString("code") == null) || (!jp.getString(
							"code").equals(data.get("code").toString())))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null)
					&& ((msg == null) || (!msg.equals(data.get("msg").toString())))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
				
			if((data.get("custom") != null) && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			
			if (jp.getString("data") != null) {
				parameter = MapUtil.getValue("parameter", data);
				/**
				 * 	public String uuid;
					public String nickname;
					public String desc;
					public String pic;
				 */
				
				uuid =jp.getString("data.uuid");
				nickname =jp.getString("data.nickname");
//				desc =jp.getString("data.data.desc[0]");
//				pic =jp.getString("data.data.pic[0]");
				
				try {
					ResultSet xyu_room_users=null;
					if(uuid!=null){
						xyu_room_users = this.selectFromDB(
								" xyu_room_users r ",
								" r.uuid = '" + Current_uuid + "' ");
						xyu_room_users.last();
						String act_nickname = String.valueOf(xyu_room_users.getString(xyu_room_users.findColumn("nickname")));
						String act_uuid = String.valueOf(xyu_room_users.getString(xyu_room_users.findColumn("uuid")));
						
						
						if (!act_uuid.equals(uuid)) {
							result = result && false;
							failReason = failReason + "uuid  is not  find;";
						} 
						if(!act_nickname.equals(nickname)){
							result = result && false;
							failReason = failReason + "nickname  is not  find;";
						}
					}
					
					
				} catch (Exception e) {
					result = result && false;
					failReason = failReason + "cannot verify xyu_room_users info in DB;";
					e.printStackTrace();
				}
			}
		}
		
		if (result){
			return "Pass";
		}else{
			return "Fail:" + failReason;
		}
	}

}
